% *************************************************************************
% Frequent Local Histogram Code (FLH)
% Created by Basura Fernando (basura.fernando@esat.kuleuven.be) 2012/08/02
%
% This MATLAB code implements basic FLH described in the paper 
%
% B. Fernando, E. Fromont, T. Tuytelaars "Effective Use of Frequent Itemset 
% Mining for Image Classification" ECCV 2012
%
% *************************************************************************
    addpath([cd '/mfiles']);
    addpath([cd '/SPMCode']);
    addpath([cd '/mycode']); 
    addpath('libsvm-3.11/matlab');    
    javaaddpath('mapper.jar'); 
    javaaddpath('call_lcm.jar'); 
    
    Params.image_dir = 'images_flower';
    Params.data_dir  ='data_flower';
    Params.image_extension = 'jpg';    
    Params.dictionarySize  = 100;  
    Params.canSkip         = 1;
    Params.gridSpacing     = 8;
    Params.patchSize       = 4;
    Params.maxImageSize    = 1000;
    Params.numTextonImages = 500;
    Params.sift_bin_size   = 2; 
    Params.knn             = [ 5 ];
    Params.LCM_K           = '';
    Params.LCM_U           = '100';
    Params.LCM_S           = '20';
    Params.LCM_NUM_THREADS = 2;
    Params.FILTERING_METHOD= 1;
    Params.RELEVANT_PATTERNS= 10000;  
    flower_dataset;    
    Params.filenames = filenames;
    Params.trainset = trainset;
    Params.testset = testset;
    Params.labels = labels;
    Params.trnlbl = labels; 	  
    Params.datasetnm = 'flower';
    Params.num_classes = 17;
    Params.train_image_count = 15;
    Params.images_per_class  = 20;
