% *************************************************************************
% Frequent Local Histogram Code (FLH)
% Created by Basura Fernando (basura.fernando@esat.kuleuven.be) 2012/08/02
%
% This MATLAB code implements basic FLH described in the paper 
%
% B. Fernando, E. Fromont, T. Tuytelaars "Effective Use of Frequent Itemset 
% Mining for Image Classification" ECCV 2012
%
% *************************************************************************

function Run_FLH()
    clear all;
    clc;
    FLH_Init;     
    build_everything(Params);      
    for i = 1 : size(Params.knn,2)   
        lcm_and_mapper(Params,Params.knn(i));
        flh_classifier(Params , Params.knn(i))   
    end   
end
