% *************************************************************************
% Frequent Local Histogram Code (FLH)
% Created by Basura Fernando (basura.fernando@esat.kuleuven.be) 2012/08/02
%
% This MATLAB code implements basic FLH described in the paper 
%
% B. Fernando, E. Fromont, T. Tuytelaars "Effective Use of Frequent Itemset 
% Mining for Image Classification" ECCV 2012
%
% *************************************************************************
function flh_classifier(Params , KNN)            
    binary_f_name = sprintf('FLH_%d_%d_%s_%s_%s.mat',Params.dictionarySize, KNN,str_emtry_to_FLH(Params.LCM_K), str_emtry_to_FLH(Params.LCM_U), str_emtry_to_FLH(Params.LCM_S));
    file  = fullfile(Params.data_dir , Params.datasetnm ,'FLH_Binary_Histograms' , binary_f_name);  
    sp_make_dir(sprintf('%s',file));
    if exist(file) == 2
        load(file); 
        cohist = single(cohist);        
    else
        fprintf('Some error happen before ....\n');
        return;
    end    
    [predict_label_FLH,accuracy_FLH,result_FLH] = IntersectionKernel ( sqrt(cohist), Params.labels, Params.trainset, Params.testset );     
    fprintf('Results FLH  %1.4f \n',accuracy_FLH(1,1));    
end