function [predict_label,accuracy,result,auc] = IntersectionKernel(histogram,labels,trainset,testset)
    fprintf('SVM train with Intersection Kernel..\n'); 

    [MKL_Shape, MKL_Shape_TEST] = Create_MKL_Kernel(histogram,trainset,testset,labels);
    
    if size(labels,2) == 1
        labels_index = labels;
    else
        [max1,labels_index]=max(labels,[],2);
    end
    
    train_truth=labels_index(trainset>0);
    test_truth=labels_index(testset>0);

    nTrain = size(MKL_Shape,1);
    nTest = size(MKL_Shape_TEST,1);

    index = (1:nTrain)'; 
    MKL_TR = [index MKL_Shape];

    index = (1:nTest)';    
    MKL_TEST = [index MKL_Shape_TEST]; 
     
    model=svmtrain(train_truth,MKL_TR,sprintf('-t 4 -s 1 -b 1 -c 1 -q'));
    [predict_label, accuracy , result] = svmpredict(test_truth,MKL_TEST, model,'-b 1'); 
    
    if size(labels,2) == 2
        gt = zeros(size(test_truth));
        gt = gt - 1;
        gt( find(test_truth == 1)) = 1; 
        %out = zero()
        [fp,tp,auc] = VOCroc(gt,result(:,1),false);
    else
        auc = 0;
    end 

end
