function colist = createVisualWordCoOccurrenceList(imageFileList , f, dataBaseDir,cls, k, dictionarySize,canskip)

    imageFName = imageFileList{f};
    [dirN base] = fileparts(imageFName);
    baseFName = [dirN filesep base]; 
        
               
    outFCoName = fullfile(dataBaseDir,cls,sprintf('colist_%d_%d',k,dictionarySize) ,sprintf('%s_colist.mat', baseFName));
    
    if exist(outFCoName) == 2             
        if canskip == 1
            return;
        end
        load(outFCoName);            
        return;
    end 
    outTexFName = fullfile(dataBaseDir, cls ,'hist',sprintf('%s_texton_ind_%d.mat', baseFName, dictionarySize));
    load(outTexFName);  
    
    features = texton_ind;  
    x = features.x;
    y = features.y;
    
    %locations = read_annotation_file(base,cls);    
    %[texton_ind.data,ind] = filter_sift_data_by_locations(texton_ind.data,x,y,locations);    
    
    features.x = x;
    features.y = y;
    
    word_indexes = texton_ind.data;
    
    num_Key_Points = size(word_indexes,1);
    locations = [features.x features.y];
    colist = cell(num_Key_Points,1);
    for i = 1 : num_Key_Points
         nnb = kNearestNeighbors(locations,locations(i,:),k); 
         mainWord = word_indexes(i);
         nearestWords = word_indexes(nnb);        
         colist{i}.words=nearestWords;
         colist{i}.mainword = mainWord;
    end
    sp_make_dir(outFCoName);
    save(outFCoName, 'colist'); 


end