function [filenames,LABELS,trainset,testset,imLabel] = getImageLabels(imDir,numImgTraining)
    TOTAL_IMAGES = 0;
    dirs = dir(imDir);    
    for i = 3 : size(dirs,1)
        className = dirs(i).name; 
        imageNames{i-2}.images = dir( fullfile(imDir,className,'*.jpg'));
        TOTAL_IMAGES = TOTAL_IMAGES + size(imageNames{i-2}.images,1);
    end
    
    NUM_CLASSES = size(imageNames,2);
    
    LABELS = zeros(TOTAL_IMAGES,NUM_CLASSES);
    trainset =  zeros(TOTAL_IMAGES,1);
    testset =  zeros(TOTAL_IMAGES,1);
    filenames = cell(TOTAL_IMAGES,1);
    imLabel = zeros(TOTAL_IMAGES,1);
    
    begin = 0;
    imIndex = 1;
    for i = 1 : NUM_CLASSES
        className = dirs(i+2).name;         
        numClassSpecificImages = size(imageNames{i}.images,1);       
        LABELS(begin+1:begin+numClassSpecificImages,i) = 1;
        randIndex = randperm(numClassSpecificImages);
        trIndex = randIndex(1:numImgTraining);
        TestIndex = randIndex(numImgTraining+1:numClassSpecificImages);
        trainset(begin+trIndex,:) = 1;
        testset(begin+TestIndex,:) = 1;
        for im  = 1 : numClassSpecificImages            
            filenames{imIndex,:} = fullfile(className,imageNames{i}.images(im).name);
            imLabel(imIndex,1) = i;
            imIndex=imIndex+1;            
        end
        
        begin = begin + numClassSpecificImages; 
    end

end