function [relevance_t] = redundancy_filter(histogram,labels)


[max1,labels_index]=max(labels,[],2);
 NUM_CLASSES = max(labels_index);
 NUM_DOCS = size(histogram,1);
 NUM_TERMS = size(histogram,2); 
 pct = zeros(NUM_CLASSES,NUM_TERMS);
 ptd = normalize_histogram(histogram); 
 SIM_TYPE_INTERSECTION = 1;
 SIM_TYPE_KL_DIVERGENCE = 2;
 entropy_t  = zeros(1,NUM_TERMS);
 goodness_t = zeros(1,NUM_TERMS);
 ft =  zeros(NUM_TERMS,1);
 dft =  zeros(NUM_TERMS,1);
 class_frequncy_t =  zeros(NUM_TERMS,1); 
 for  t = 1 : NUM_TERMS 
     ft(t,1) = sum(histogram(:,t));  % term frequency    
     pdt = histogram(:,t);           % term vector for all documents
     dft(t,1) = size(find(pdt),1);   % document frequency
     pdt = pdt ./ ft(t,1);           % Probablity of the document given the term        
     for c = 1 : max(labels_index)   % For each class
         pcd = labels(:,c);          % true probability of the document of class c    
         pct(c,t) = sum(pcd .* pdt); % probability of class c given term t
         pcd = pcd ./ sum(pcd);      % optimum class distribution for any term 
         sim(c) = similarity(pcd,pdt,SIM_TYPE_KL_DIVERGENCE); % find similarity between two distributions 
     end
     class_frequncy_t(t,1) = size(find(pct(:,t)>0.05),1); 
     goodness_t(1,t) = min(sim);
     entropy_t(1,t) = entropy(pct(:,t));
 end 
 mean_goodness = mean(goodness_t);
 goodness_t = exp(-goodness_t ./ mean_goodness); 
 Discriminative_Score_t = (1-entropy_t); 
 relevance_t = Discriminative_Score_t .* goodness_t; 
 

 % for best results call MMRAlgo but super slow.....
 
 return;
 

%% MMRAlgo
% [max_rel,max_t]=max(relevance_t);
% K = 1000;  
% i = 1;
% relevant_list(i) = max_t;
% while i < K || i == NUM_TERMS
%     G = zeros(1,NUM_TERMS);
%     for k = 1 : NUM_TERMS
%         found = 0;
%         for r = 1 : size(relevant_list,2)
%             if relevant_list(r) == k
%                 found = 1;
%             end
%         end
%         
%         if found == 0
%             for r = 1 : size(relevant_list,2)
%                 relPat = histogram(:,relevant_list(r))./sum(histogram(:,relevant_list(r)));
%                 canPat = histogram(:,k)./sum(histogram(:,k));
%                 prRelPat = ft(relevant_list(r),1);
%                 prCanPat = ft(k,1);
%                 combinedPat = relPat .* prRelPat +  canPat .* prCanPat/ (prRelPat + prCanPat );
%                 MI  = prRelPat * similarity(relPat,combinedPat,SIM_TYPE_KL_DIVERGENCE) + prCanPat * similarity(canPat,combinedPat,SIM_TYPE_KL_DIVERGENCE);
%                 R   = exp(-MI) * min(relevance_t(relevant_list(r)) , relevance_t(k));
%                 G(k)= relevance_t(k) -  R;
%             end 
%         end
%         
%     end
%     [max_rel,max_t] = max(G);
%     i = i + 1;
%     fprintf('add pattern : %d  now added patterns : %d \n',max_t,i);
%     relevant_list(i) = max_t;
% end
%% End of MMR



end